; QYOu (C)ENIX p
; C[` (for NASM)

%include 'hoot.inc'

		ORG	0x0100
		USE16
		CPU	186

start:		cli
		mov	sp,stack
		mov	bx,prgend
		shr	bx,4
		mov	ah,0x4a		; [DOS] ubN̏k(ES:BX)
		int	0x21
		jnc	.skip1
		hlt
.skip1:		mov	bx,0x5000	; 傫K
		mov	ah,0x48		; [DOS] 蓖
		int	0x21
		jnc	.skip2
		hlt
.skip2:		mov	[paramblk],ax	; 蓖ăAhXۑ
		mov	[paramblk+2],ax
		add	ax,0x14ea	; TEhhCoZOg̃ItZbg
		mov	[playentry+2],ax
		mov	[stopentry+2],ax
		mov	[fadeentry+2],ax
		mov	[infoentry+2],ax
		mov	[efcsetentry+2],ax
		mov	[effectentry+2],ax
		mov	ax,0x4b03	; [DOS] Overlay Load
		mov	dx,exec_path	; pX (DS:DX)
		mov	bx,paramblk	; p[^ubN(ES:BX)
		int	0x21
		jnc	.skip3
		hlt
.skip3:		call	far [infoentry]	; ȃf[^ZOg擾(DX:AX)
		mov	[music_ofs],ax
		mov	[music_seg],dx
		add	ax,0x1500 + 0x380	; ʉf[^AhXvZ(ʉf[^+0x0380ɔzu)
		mov	[effect_ofs],ax
		mov	[effect_seg],dx

		mov	ax,0x3d00	; [DOS] File Open
		mov	dx,se_path	; ʉf[^t@CI[v
		int	0x21
		jc	.skip4

		xchg	bx,ax		; t@Cnhۑ
		push	ds
		mov	ah,0x3f		; [DOS] File Read
		lds	dx,[effect_ofs]	; [hAhX
		mov	cx,0xffff	; TCYK
		int	0x21		; ʉf[^[h
		pop	ds

.skip4:		mov	ax,0x257f	; hoothCoo^
		mov	dx,vect_7f
		int	0x21

		sti
mainloop:	mov	ax,0x9801	; _~[|[O
		int	0x18
		jmp	short mainloop

; hootR[
; inp8(HOOTPORT) = 0  PC98DOS::Play
; inp8(HOOTPORT) = 2  PC98DOS::Stop
; _code = inp8(HOOTPORT+2)`inp8(HOOTPORT+5)

vect_7f:	pusha
		push	ds
		push	es
		mov	ax,cs
		mov	ds,ax
		mov	es,ax
		mov	dx,HOOTPORT
		in	al,dx
		cmp	al,HP_PLAY
		jz	short .play
		cmp	al,HP_STOP
		jz	short .stop
.ed:		pop	es
		pop	ds
		popa
		iret

.play:		mov	dx,HOOTPORT+2
		in	al,dx
		cmp	al,0xff		; 0xFFwȂʉt
		jz	.effect

		call	far [stopentry]	; t~
		cli
		push	ds
		lds	dx,[music_ofs]	; [hAhX
		xor	bx,bx		; W
		mov	cx,0xffff	; TCYK
		mov	ah,0x3f		; ȃf[^{̂̃[h (DS:DX)
		int	0x21
		pop	ds
		jc	.ed
		call	far [playentry]	; tJn
		jmp	short .ed

.stop:		call	far [stopentry]	; t~
		jmp	short .ed

.fadeout:	call	far [fadeentry]	; tF[hAEg
		jmp	short .ed

.effect:	inc	dx
		in	al,dx		; ʉԍ擾
		push	ax		; ʉԍX^bNɐς
		call	far [efcsetentry]	; ʉԍ̃Zbg
		pop	ax
		call	far [effectentry]	; ʉt
		jmp	short .ed

; ȃf[^AhX
music_ofs:	dw	0
music_seg:	dw	0

; ʉf[^AhX
effect_ofs:	dw	0
effect_seg:	dw	0

; I[oC[hppX
exec_path:	db	'S.EXE',00

; ʉpt@C
se_path:	db	'SE.MUX',00

; far callpGg
playentry:	dw	0x0000		; tJn
		dw	0
		
stopentry:	dw	0x000c		; t~
		dw	0
		
fadeentry:	dw	0x0018		; tF[hAEg(A~Ȃ)
		dw	0

infoentry:	dw	0x0058		; ȃf[^̃ZOg擾(DX:AX)
		dw	0

efcsetentry:	dw	0x0045		; ʉԍZbg
		dw	0

effectentry:	dw	0x0024		; ʉt
		dw	0

; I[oC[hpp[^ubN
paramblk:	dw	0		; [hZOg
		dw	0		; P[Vt@N^

		times 0x200 db 0x00	; X^bNGA
stack:

		align	0x10
prgend:		

		ends

